
Ruby - Bug #9813

Module#initialize_copy does not clean the tables

05/08/2014 04:38 AM - nobu (Nobuyoshi Nakada)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: r45873 Backport: 2.0.0: DONE, 2.1: DONE

Description

Module#initialize_copyで定数やインスタンス変数を持たないModuleをコピーしても、元の定数やインスタンス変数が残っています。

m = Module.new do

  def x

  end

  const_set(:X, 1)

  @x = 2

end

p m.instance_methods, m.instance_variables, m.constants

#=> [:x]

#=> [:@x]

#=> [:X]

m.module_eval do

  initialize_copy(Module.new)

end

p m.instance_methods, m.instance_variables, m.constants

#=> []

#=> [:@x]

#=> [:X]

 1.8でinitialize_copyが導入された当初からあるバグのようです。

Associated revisions

Revision 7c072b35d18391b9a1f848c6adc707c3ebbb1791 - 05/08/2014 05:34 AM - nobu (Nobuyoshi Nakada)

class.c: always clear tables first

class.c (rb_mod_init_copy): always clear instance variable,

constant and method tables first, regardless the source tables.

[ruby-dev:48182] [Bug #9813]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@45874 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7c072b35 - 05/08/2014 05:34 AM - nobu (Nobuyoshi Nakada)

class.c: always clear tables first

class.c (rb_mod_init_copy): always clear instance variable,

constant and method tables first, regardless the source tables.

[ruby-dev:48182] [Bug #9813]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@45874 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 9f982bd59d6e3e5e4c2c5ca20bdef79df4f8b5c0 - 06/22/2014 05:52 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r45874: [Backport #9813]

    * class.c (rb_mod_init_copy): always clear instance variable,

      constant and method tables first, regardless the source tables.

      [ruby-dev:48182] [Bug #9813]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@46498 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 9f982bd5 - 06/22/2014 05:52 PM - nagachika (Tomoyuki Chikanaga)
merge revision(s) r45874: [Backport #9813]

    * class.c (rb_mod_init_copy): always clear instance variable,

      constant and method tables first, regardless the source tables.

      [ruby-dev:48182] [Bug #9813]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@46498 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d848edb1d5ee68896950e9b5fe3e57badfdfb680 - 06/23/2014 09:58 AM - U.Nakamura 

merge revision(s) 45874: [Backport #9813]

    * class.c (rb_mod_init_copy): always clear instance variable,

      constant and method tables first, regardless the source tables.

      [ruby-dev:48182] [Bug #9813]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@46519 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d848edb1 - 06/23/2014 09:58 AM - U.Nakamura 

merge revision(s) 45874: [Backport #9813]

    * class.c (rb_mod_init_copy): always clear instance variable,

      constant and method tables first, regardless the source tables.

      [ruby-dev:48182] [Bug #9813]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@46519 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/08/2014 05:34 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset r45874.

class.c: always clear tables first

class.c (rb_mod_init_copy): always clear instance variable,

constant and method tables first, regardless the source tables.

[ruby-dev:48182] [Bug #9813]

#2 - 06/22/2014 05:52 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED to 2.0.0: REQUIRED, 2.1: DONE

Backported into ruby_2_1 branch at r46498.

#3 - 06/23/2014 09:59 AM - usa (Usaku NAKAMURA)

backported into ruby_2_0_0 at r46519.

#4 - 06/27/2014 07:53 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: REQUIRED, 2.1: DONE to 2.0.0: DONE, 2.1: DONE
